#ifdef __GNUG__
#pragma interface
#endif

template <class ELEM, class KEYT, long KEY>
class SharedCol : public GenSharedCol {
friend class SharedIterator<ELEM, KEYT, KEY> ;
  
  private :

  Ref<DictX<ELEM, KEYT, KEY> > _newElemList ;
  Ref<DictX<ELEM, KEYT, KEY> > _savElemList ;

  static void commit(GenSharedMod*) ;
  void ((*registerCommit() const)(GenSharedMod*)) { return commit ; } 
  void init() const ;
  GenSharedMod* createMod() const ;
  DictXGen* savElemList() const { return (DictXGen*)_savElemList ; }
  DictXGen* newElemList() const { return (DictXGen*)_newElemList ; }
  int member(const Ref<ObjectX>& obj) const {
    return this->member(*(Ref<ELEM>*)&obj) ;
  }
  int insert(const Ref<ObjectX>& obj) {
    return this->insert(*(Ref<ELEM>*)&obj) ;
  }
  
  public :
  
  SharedCol() ;
  SharedCol(const SharedCol<ELEM, KEYT, KEY>&) ;
    
  SharedCol<ELEM, KEYT, KEY>& operator=(const SharedCol<ELEM, KEYT, KEY>&) ;

  int operator==(const SharedCol<ELEM, KEYT, KEY>& col) const {
    return this->GenSharedCol::operator==(col) ;
  }

  int operator!=(const SharedCol<ELEM, KEYT, KEY>& col) const {
    return this->GenSharedCol::operator!=(col) ;
  }

  SharedCol<ELEM, KEYT, KEY>& operator+=(const Ref<ELEM>& obj) {
    this->insert(obj) ; return *this ;
  }
  
  SharedCol<ELEM, KEYT, KEY>& operator+=(const LocalListX<ELEM>& l) {
    this->insert(l) ; return *this ;
  }

  SharedCol<ELEM, KEYT, KEY>& operator+=(const SharedCol<ELEM, KEYT, KEY>& c)
  {
    this->insert(c) ; return *this ;
  }

  SharedCol<ELEM, KEYT, KEY>& operator-=(const Ref<ELEM>& obj) {
    this->remove(obj) ; return *this ;
  }

  Ref<ELEM> get(const KEYT&) ;

  int insert(const Ref<ELEM>& obj) ;

  int insert(const LocalListX<ELEM>& l) {
    return this->GenSharedCol::insert(*(LocalListX<ObjectX>*)&l) ;
  }

  int insert(const SharedCol<ELEM, KEYT, KEY>& col) {
    return this->GenSharedCol::insert(col) ;
  }
  
  int remove(const Ref<ELEM>&) ;

  int remove(const KEYT& k) {
    Ref<ELEM> elem = this->get(k) ;
    if (elem != NULL) return this->remove(elem) ;
  }

  int member(const Ref<ELEM>& obj) const ;
} ;


template <class ELEM, class KEYT, long KEY>
class SharedIterator : public GenSharedIterator {

  const SharedCol<ELEM, KEYT, KEY>& _col ;

  public :

  SharedIterator(const SharedCol<ELEM, KEYT, KEY>& c)
  : _col(c), GenSharedIterator(c) {} ;

  Ref<ELEM>& get() const {
    return *(Ref<ELEM>*)&this->GenSharedIterator::get() ;
  }

  int  go(const Ref<ELEM>&) ;
} ;


template <class ELEM>
class SharedSet : public SharedCol<ELEM, OID, yoo_index(ObjectX::_oid)> {} ;

template <class ELEM>
class SharedSetIterator:public SharedIterator<ELEM,OID,yoo_index(ObjectX::_oid)>
{
  public :
  SharedSetIterator(const SharedSet<ELEM>& s) :
  SharedIterator<ELEM, OID, yoo_index(ObjectX::_oid)>(s) {} ;
} ;


template <class ELEM, class KEYT, long KEY>
class SharedDict : public SharedCol<ELEM, KEYT, KEY> {} ;

template <class ELEM, class KEYT, long KEY>
class SharedDictIterator : public SharedIterator<ELEM, KEYT, KEY> 
{
  public :
  SharedDictIterator(const SharedDict<ELEM, KEYT, KEY>& s) :
  SharedIterator<ELEM, KEYT, KEY>(s) {} ;
} ;

